Index: palm/trunk/SOURCE/fft_xy.f90
===================================================================
--- palm/trunk/SOURCE/fft_xy.f90	(revision 1105)
+++ palm/trunk/SOURCE/fft_xy.f90	(revision 1106)
@@ -572,9 +1265,9 @@
           message_string = 'fft method "' // TRIM( fft_method) // &
                            '" not available'
-          CALL message( 'fft_y', 'PA0189', 1, 2, 0, 6, 0 )
+          CALL message( 'fft_y_1d', 'PA0189', 1, 2, 0, 6, 0 )
 
        ENDIF
 
-    END SUBROUTINE fft_y
+    END SUBROUTINE fft_y_1d
 
     SUBROUTINE fft_x_m( ar, direction )
@@ -654,5 +1347,5 @@
 !--          Tables are initialized once more. This call should not be
 !--          necessary, but otherwise program aborts in asymmetric case
-             CALL DZFFTM( 0, nx+1, nz1, sqr_nx, work, nx+4, work, nx+4, &
+             CALL DZFFTM( 0, nx+1, nz1, sqr_dnx, work, nx+4, work, nx+4, &
                           trig_xf, work1, 0 )
 
@@ -662,5 +1355,5 @@
              ENDIF
 
-             CALL DZFFTM( 1, nx+1, nz1, sqr_nx, ai, siza, work, sizw, &
+             CALL DZFFTM( 1, nx+1, nz1, sqr_dnx, ai, siza, work, sizw, &
                           trig_xf, work1, 0 )
 
@@ -679,5 +1372,5 @@
 !--          Tables are initialized once more. This call should not be
 !--          necessary, but otherwise program aborts in asymmetric case
-             CALL ZDFFTM( 0, nx+1, nz1, sqr_nx, work, nx+4, work, nx+4, &
+             CALL ZDFFTM( 0, nx+1, nz1, sqr_dnx, work, nx+4, work, nx+4, &
                           trig_xb, work1, 0 )
 
@@ -693,5 +1386,5 @@
              ENDDO
 
-             CALL ZDFFTM( -1, nx+1, nz1, sqr_nx, work, sizw, ai, siza, &
+             CALL ZDFFTM( -1, nx+1, nz1, sqr_dnx, work, sizw, ai, siza, &
                           trig_xb, work1, 0 )
 
@@ -791,5 +1484,5 @@
 !--          Tables are initialized once more. This call should not be
 !--          necessary, but otherwise program aborts in asymmetric case
-             CALL DZFFTM( 0, ny+1, nz1, sqr_ny, work, ny+4, work, ny+4, &
+             CALL DZFFTM( 0, ny+1, nz1, sqr_dny, work, ny+4, work, ny+4, &
                           trig_yf, work1, 0 )
 
@@ -799,5 +1492,5 @@
              ENDIF
 
-             CALL DZFFTM( 1, ny+1, nz1, sqr_ny, ai, siza, work, sizw, &
+             CALL DZFFTM( 1, ny+1, nz1, sqr_dny, ai, siza, work, sizw, &
                           trig_yf, work1, 0 )
 
@@ -816,5 +1509,5 @@
 !--          Tables are initialized once more. This call should not be
 !--          necessary, but otherwise program aborts in asymmetric case
-             CALL ZDFFTM( 0, ny+1, nz1, sqr_ny, work, ny+4, work, ny+4, &
+             CALL ZDFFTM( 0, ny+1, nz1, sqr_dny, work, ny+4, work, ny+4, &
                           trig_yb, work1, 0 )
 
@@ -830,5 +1523,5 @@
              ENDDO
 
-             CALL ZDFFTM( -1, ny+1, nz1, sqr_ny, work, sizw, ai, siza, &
+             CALL ZDFFTM( -1, ny+1, nz1, sqr_dny, work, sizw, ai, siza, &
                           trig_yb, work1, 0 )
 
@@ -852,3 +1545,4 @@
     END SUBROUTINE fft_y_m
 
+
  END MODULE fft_xy
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 1105)
+++ palm/trunk/SOURCE/header.f90	(revision 1106)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! some format changes for coupled runs
 !
 ! Former revisions:
@@ -192,5 +192,5 @@
     CHARACTER (LEN=10) ::  coor_chr, host_chr
     CHARACTER (LEN=16) ::  begin_chr
-    CHARACTER (LEN=23) ::  ver_rev
+    CHARACTER (LEN=26) ::  ver_rev
     CHARACTER (LEN=40) ::  output_format
     CHARACTER (LEN=70) ::  char1, char2, dopr_chr, &
@@ -258,4 +258,11 @@
        WRITE ( io, 101 )  mpi_type, coupling_mode
     ENDIF
+    IF ( coupling_start_time /= 0.0 )  THEN
+       IF ( coupling_start_time > simulated_time_at_begin )  THEN
+          WRITE ( io, 109 )
+       ELSE
+          WRITE ( io, 114 )
+       ENDIF
+    ENDIF
     WRITE ( io, 102 )  run_date, run_identifier, run_time, runnr, &
                        ADJUSTR( host_chr )
@@ -426,7 +433,7 @@
        IF ( time_restart /= 9999999.9  .AND.  time_restart < end_time )  THEN
           IF ( dt_restart == 9999999.9 )  THEN
-             WRITE ( io, 204 )  ' Next restart at:  ',time_restart
+             WRITE ( io, 204 )  ' Next restart at:     ',time_restart
           ELSE
-             WRITE ( io, 205 )  ' Next restart at:  ',time_restart, dt_restart
+             WRITE ( io, 205 )  ' Next restart at:     ',time_restart, dt_restart
           ENDIF
        ENDIF
@@ -435,14 +442,8 @@
 !
 !-- Start time for coupled runs, if independent precursor runs for atmosphere
-!-- and ocean are used. In this case, coupling_start_time defines the time
-!-- when the coupling is switched on.
+!-- and ocean are used or have been used. In this case, coupling_start_time
+!-- defines the time when the coupling is switched on.
     IF ( coupling_start_time /= 0.0 )  THEN
-       IF ( coupling_start_time >= simulated_time_at_begin )  THEN
-          char1 = 'Precursor run for a coupled atmosphere-ocean run'
-       ELSE
-          char1 = 'Coupled atmosphere-ocean run following independent ' // &
-                  'precursor runs'
-       ENDIF
-       WRITE ( io, 207 )  char1, coupling_start_time
+       WRITE ( io, 207 )  coupling_start_time
     ENDIF
 
@@ -1581,14 +1582,14 @@
 
  99 FORMAT (1X,78('-'))
-100 FORMAT (/1X,'***************************',9X,42('-')/        &
-            1X,'* ',A,' *',9X,A/                               &
-            1X,'***************************',9X,42('-'))
+100 FORMAT (/1X,'******************************',6X,42('-')/        &
+            1X,'* ',A,' *',6X,A/                               &
+            1X,'******************************',6X,42('-'))
 101 FORMAT (37X,'coupled run using MPI-',I1,': ',A/ &
             37X,42('-'))
-102 FORMAT (/' Date:              ',A8,9X,'Run:       ',A20/      &
-            ' Time:              ',A8,9X,'Run-No.:   ',I2.2/     &
-            ' Run on host:     ',A10)
+102 FORMAT (/' Date:                 ',A8,6X,'Run:       ',A20/      &
+            ' Time:                 ',A8,6X,'Run-No.:   ',I2.2/     &
+            ' Run on host:        ',A10)
 #if defined( __parallel )
-103 FORMAT (' Number of PEs:',8X,I5,9X,'Processor grid (x,y): (',I3,',',I3, &
+103 FORMAT (' Number of PEs:',10X,I6,6X,'Processor grid (x,y): (',I3,',',I3, &
               ')',1X,A)
 104 FORMAT (' Number of PEs:',8X,I5,9X,'Tasks:',I4,'   threads per task:',I4/ &
@@ -1599,4 +1600,9 @@
 107 FORMAT (37X,'A 1d-decomposition along ',A,' is used')
 108 FORMAT (37X,'Max. # of parallel I/O streams is ',I5)
+109 FORMAT (37X,'Precursor run for coupled atmos-ocean run'/ &
+            37X,42('-'))
+114 FORMAT (37X,'Coupled atmosphere-ocean run following'/ &
+            37X,'independent precursor runs'/             &
+            37X,42('-'))
 #endif
 110 FORMAT (/' Numerical Schemes:'/ &
@@ -1610,6 +1616,6 @@
                   ' or Upstream')
 118 FORMAT (' --> Scalar advection via Bott-Chlond-Scheme')
-119 FORMAT (' --> Galilei-Transform applied to horizontal advection', &
-            '     Translation velocity = ',A/ &
+119 FORMAT (' --> Galilei-Transform applied to horizontal advection:'/ &
+            '     translation velocity = ',A/ &
             '     distance advected ',A,':  ',F8.3,' km(x)  ',F8.3,' km(y)')
 122 FORMAT (' --> Time differencing scheme: ',A)
@@ -1656,17 +1662,17 @@
 200 FORMAT (//' Run time and time step information:'/ &
              ' ----------------------------------'/)
-201 FORMAT ( ' Timestep:          variable     maximum value: ',F6.3,' s', &
+201 FORMAT ( ' Timestep:             variable     maximum value: ',F6.3,' s', &
              '    CFL-factor: ',F4.2)
-202 FORMAT ( ' Timestep:       dt = ',F6.3,' s'/)
-203 FORMAT ( ' Start time:       ',F9.3,' s'/ &
-             ' End time:         ',F9.3,' s')
+202 FORMAT ( ' Timestep:          dt = ',F6.3,' s'/)
+203 FORMAT ( ' Start time:          ',F9.3,' s'/ &
+             ' End time:            ',F9.3,' s')
 204 FORMAT ( A,F9.3,' s')
 205 FORMAT ( A,F9.3,' s',5X,'restart every',17X,F9.3,' s')
-206 FORMAT (/' Time reached:     ',F9.3,' s'/ &
-             ' CPU-time used:    ',F9.3,' s     per timestep:               ', &
-               '  ',F9.3,' s'/                                                 &
-             '                                   per second of simulated tim', &
+206 FORMAT (/' Time reached:        ',F9.3,' s'/ &
+             ' CPU-time used:       ',F9.3,' s     per timestep:               ', &
+               '  ',F9.3,' s'/                                                    &
+             '                                   per second of simulated tim',    &
                'e: ',F9.3,' s')
-207 FORMAT ( A/' Coupling start time:',F9.3,' s')
+207 FORMAT ( ' Coupling start time: ',F9.3,' s')
 250 FORMAT (//' Computational grid and domain size:'/ &
               ' ----------------------------------'// &
Index: palm/trunk/SOURCE/microphysics.f90
===================================================================
--- palm/trunk/SOURCE/microphysics.f90	(revision 1105)
+++ palm/trunk/SOURCE/microphysics.f90	(revision 1106)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! small changes in code formatting
 !
 ! Former revisions:
@@ -111,4 +111,5 @@
     END SUBROUTINE dsd_properties
 
+
     SUBROUTINE autoconversion
 
@@ -133,4 +134,5 @@
     END SUBROUTINE autoconversion
 
+
     SUBROUTINE accretion
 
@@ -155,4 +157,5 @@
     END SUBROUTINE accretion
 
+
     SUBROUTINE selfcollection_breakup
 
@@ -177,4 +180,5 @@
     END SUBROUTINE selfcollection_breakup
 
+
     SUBROUTINE evaporation_rain
 
@@ -199,4 +203,5 @@
     END SUBROUTINE evaporation_rain
 
+
     SUBROUTINE sedimentation_cloud
 
@@ -221,4 +226,5 @@
     END SUBROUTINE sedimentation_cloud
 
+
     SUBROUTINE sedimentation_rain
 
@@ -240,5 +246,4 @@
           ENDDO
        ENDDO
-
 
     END SUBROUTINE sedimentation_rain
@@ -293,4 +298,5 @@
     END SUBROUTINE dsd_properties_ij
 
+
     SUBROUTINE autoconversion_ij( i, j )
 
@@ -308,4 +314,5 @@
        REAL    ::  k_au, autocon, phi_au, tau_cloud, xc, nu_c, rc,   &
                    l_mix, re_lambda, alpha_cc, r_cc, sigma_cc, epsilon
+
 
        k_au = k_cc / ( 20.0 * x0 )
@@ -370,7 +377,8 @@
 !--          Tendencies for q, qr, nr, pt:
              tend_qr(k,j,i) = tend_qr(k,j,i) + autocon
-             tend_q(k,j,i)  = tend_q(k,j,i) - autocon
+             tend_q(k,j,i)  = tend_q(k,j,i)  - autocon
              tend_nr(k,j,i) = tend_nr(k,j,i) + autocon / x0 * hyrho(k)
-             tend_pt(k,j,i) = tend_pt(k,j,i) + autocon * l_d_cp * pt_d_t(k) 
+             tend_pt(k,j,i) = tend_pt(k,j,i) + autocon * l_d_cp * pt_d_t(k)
+
           ENDIF
 
@@ -378,4 +386,5 @@
 
     END SUBROUTINE autoconversion_ij
+
 
     SUBROUTINE accretion_ij( i, j )
@@ -394,4 +403,5 @@
 
        DO  k = nzb_2d(j,i)+1, nzt
+
           IF ( ( ql(k,j,i) > 0.0 )  .AND.  ( qr(k,j,i) > eps_sb ) )  THEN
 !
@@ -422,7 +432,9 @@
 !--          Tendencies for q, qr, pt:
              tend_qr(k,j,i) = tend_qr(k,j,i) + accr
-             tend_q(k,j,i)  = tend_q(k,j,i) - accr
+             tend_q(k,j,i)  = tend_q(k,j,i)  - accr
              tend_pt(k,j,i) = tend_pt(k,j,i) + accr * l_d_cp * pt_d_t(k) 
+
           ENDIF
+
        ENDDO
 
@@ -444,5 +456,7 @@
        REAL    ::  selfcoll, breakup, phi_br, phi_sc
 
+
        DO  k = nzb_2d(j,i)+1, nzt
+
           IF ( qr(k,j,i) > eps_sb )  THEN
 !
@@ -469,8 +483,11 @@
 !--          Tendency for nr:
              tend_nr(k,j,i) = tend_nr(k,j,i) + selfcoll
+
           ENDIF          
+
        ENDDO
 
     END SUBROUTINE selfcollection_breakup_ij
+
 
     SUBROUTINE evaporation_rain_ij( i, j )
@@ -492,5 +509,7 @@
                    mu_r_2, mu_r_5d2, nr_0
 
+
        DO  k = nzb_2d(j,i)+1, nzt
+
           IF ( qr(k,j,i) > eps_sb )  THEN
 !
@@ -506,5 +525,5 @@
              q_s = q_s * ( 1.0 + alpha * q(k,j,i) ) / ( 1.0 + alpha * q_s )
 !
-!--          Oversaturation:
+!--          Supersaturation:
              sat = MIN( 0.0, ( q(k,j,i) - ql(k,j,i) ) / q_s - 1.0 )
 !
@@ -550,16 +569,19 @@
              evap = 2.0 * pi * nr_0 * g_evap * f_vent * sat /    &
                     hyrho(k)
-             evap = MAX( evap, -qr(k,j,i) / ( dt_3d *                         &
+             evap = MAX( evap, -qr(k,j,i) / ( dt_3d *            &
                          weight_substep(intermediate_timestep_count) ) )
 !
 !--          Tendencies for q, qr, nr, pt:
              tend_qr(k,j,i) = tend_qr(k,j,i) + evap
-             tend_q(k,j,i)  = tend_q(k,j,i) - evap
+             tend_q(k,j,i)  = tend_q(k,j,i)  - evap
              tend_nr(k,j,i) = tend_nr(k,j,i) + c_evap * evap / xr(k) * hyrho(k)
              tend_pt(k,j,i) = tend_pt(k,j,i) + evap * l_d_cp * pt_d_t(k) 
+
           ENDIF          
+
        ENDDO
 
     END SUBROUTINE evaporation_rain_ij
+
 
     SUBROUTINE sedimentation_cloud_ij( i, j )
@@ -575,4 +597,5 @@
        INTEGER ::  i, j, k
        REAL    ::  sed_q_const, sigma_gc = 1.3, k_st = 1.2E8
+
 !
 !--    Sedimentation of cloud droplets (Heus et al., 2010):
@@ -589,5 +612,5 @@
        ENDDO
 !
-!--   Tendency for q, pt:
+!--    Tendency for q, pt:
        DO  k = nzb_2d(j,i)+1, nzt
           tend_q(k,j,i)  = tend_q(k,j,i) + ( sed_q(k+1) - sed_q(k) ) *        &
@@ -599,4 +622,5 @@
     END SUBROUTINE sedimentation_cloud_ij
 
+
     SUBROUTINE sedimentation_rain_ij( i, j )
 
@@ -618,5 +642,4 @@
 !--    Computation of sedimentation flux. Implementation according to Stevens
 !--    and Seifert (2008).
-
        IF ( intermediate_timestep_count == 1 )  prr(:,j,i) = 0.0
 
@@ -678,6 +701,8 @@
 
        ELSE
+
           nr_slope = 0.0
           qr_slope = 0.0
+
        ENDIF
 !
@@ -715,5 +740,7 @@
           k_run = k
           c_run = MIN( 1.0, c_qr(k) )
+
           DO WHILE ( c_run > 0.0  .AND.  k_run <= nzt-1 )
+
              flux  = flux + hyrho(k_run) *                                    &
                      ( qr(k_run,j,i) + qr_slope(k_run) * ( 1.0 - c_run ) *    &
@@ -722,4 +749,5 @@
              k_run = k_run + 1
              c_run = MIN( 1.0, c_qr(k_run) - z_run * ddzu(k_run) )
+
           ENDDO
 !
@@ -748,4 +776,5 @@
 
     END SUBROUTINE sedimentation_rain_ij
+
 
 !
@@ -761,4 +790,5 @@
        REAL    ::  gamm, ser, tmp, x_gamm, xx, y_gamm
        INTEGER ::  j 
+
  
        x_gamm = xx 
@@ -767,8 +797,10 @@
        tmp = ( x_gamm + 0.5 ) * LOG( tmp ) - tmp 
        ser = 1.000000000190015 
-       do j = 1, 6 
+
+       DO  j = 1, 6 
           y_gamm = y_gamm + 1.0 
           ser    = ser + cof( j ) / y_gamm 
-       enddo 
+       ENDDO
+
 ! 
 !--    Until this point the algorithm computes the logarithm of the gamma 
@@ -776,4 +808,5 @@
 !       gamm = EXP( tmp + LOG( stp * ser / x_gamm ) ) 
        gamm = EXP( tmp ) * stp * ser / x_gamm 
+
        RETURN 
  
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 1105)
+++ palm/trunk/SOURCE/modules.f90	(revision 1106)
@@ -20,5 +20,8 @@
 ! Current revisions:
 ! ------------------
-! test: different dpk definition for CUDA FFT
+! test: different dpk definition for CUDA FFT  removed!!!! delete this comment
+! before next check in
+! array_kind renamed precision_kind, pdims defined in serial code
+! bugfix: default value assigned to coupling_start_time
 !
 ! Former revisions:
@@ -366,5 +369,5 @@
 
 
- MODULE array_kind
+ MODULE precision_kind
 
 !------------------------------------------------------------------------------!
@@ -378,13 +381,7 @@
                            spk = SELECTED_REAL_KIND( 6 )
 
-!-- test for CUDA FFT
-!    INTEGER, PARAMETER ::  single_kind = KIND( 0.0 ), &
-!                           double_kind = KIND( 0.0D0 )
-
-!    INTEGER, PARAMETER ::  dpk = double_kind
-
-    SAVE
-
- END MODULE array_kind
+    SAVE
+
+ END MODULE precision_kind
 
 
@@ -399,5 +396,5 @@
 !------------------------------------------------------------------------------!
 
-    USE array_kind
+    USE precision_kind
 
     REAL, DIMENSION(:), ALLOCATABLE ::                                         &
@@ -781,5 +778,5 @@
              canyon_wall_left = 9999999.9, canyon_wall_south = 9999999.9, &
              cthf = 0.0, cfl_factor = -1.0, cos_alpha_surface, &
-             coupling_start_time, disturbance_amplitude = 0.25, &
+             coupling_start_time = 0.0, disturbance_amplitude = 0.25, &
              disturbance_energy_limit = 0.01, &
              disturbance_level_b = -9999999.9, &
@@ -1367,5 +1364,5 @@
 !------------------------------------------------------------------------------!
 
-    USE array_kind
+    USE precision_kind
 
     CHARACTER (LEN=15)  ::  bc_par_lr = 'cyclic',  bc_par_ns = 'cyclic', &
@@ -1475,10 +1472,12 @@
 #endif
 #endif
-    CHARACTER(LEN=5)       ::  myid_char = ''
-    INTEGER                ::  acc_rank, id_inflow = 0, id_recycling = 0,      &
-                               myid = 0, num_acc_per_node = 0,                 &
-                               target_id, npex = -1, npey = -1, numprocs = 1,  &
-                               numprocs_previous_run = -1,                     &
-                               tasks_per_node = -9999, threads_per_task = 1
+    CHARACTER(LEN=5) ::  myid_char = ''
+    INTEGER          ::  acc_rank, id_inflow = 0, id_recycling = 0,      &
+                         myid = 0, num_acc_per_node = 0,                 &
+                         target_id, npex = -1, npey = -1, numprocs = 1,  &
+                         numprocs_previous_run = -1,                     &
+                         tasks_per_node = -9999, threads_per_task = 1
+
+    INTEGER          ::  pdims(2) = 1
 
     INTEGER, DIMENSION(:,:), ALLOCATABLE ::  hor_index_bounds, &
@@ -1498,5 +1497,5 @@
                 type_x, type_x_int, type_xy, type_y, type_y_int
 
-    INTEGER ::  ibuf(12), pcoord(2), pdims(2)
+    INTEGER ::  ibuf(12), pcoord(2)
 
 #if ! defined ( __check )
Index: palm/trunk/SOURCE/poisfft.f90
===================================================================
--- palm/trunk/SOURCE/poisfft.f90	(revision 1105)
+++ palm/trunk/SOURCE/poisfft.f90	(revision 1106)
@@ -20,5 +20,7 @@
 ! Current revisions:
 ! -----------------
-! 
+! routines fftx, ffty, fftxp, fftyp removed, calls replaced by fft_x, fft_y,
+! in the 1D-decomposition routines fft_x, ffty are replaced by fft_x_1d,
+! fft_y_1d
 !
 ! Former revisions:
@@ -237,5 +239,5 @@
 
           CALL cpu_log( log_point_s(4), 'fft_x', 'start' )
-          CALL fftxp( ar, 'forward' )
+          CALL fft_x( ar, 'forward' )
           CALL cpu_log( log_point_s(4), 'fft_x', 'pause' )
 
@@ -247,5 +249,5 @@
 
           CALL cpu_log( log_point_s(7), 'fft_y', 'start' )
-          CALL fftyp( ar, 'forward' )
+          CALL fft_y( ar, 'forward' )
           CALL cpu_log( log_point_s(7), 'fft_y', 'pause' )
 
@@ -257,5 +259,5 @@
 
 !
-!--       Solve the Poisson equation in z-direction in cartesian space.
+!--       Solve the tridiagonal equation system along z
           CALL cpu_log( log_point_s(6), 'tridia', 'start' )
           CALL tridia( ar )
@@ -270,5 +272,5 @@
 
           CALL cpu_log( log_point_s(7), 'fft_y', 'continue' )
-          CALL fftyp( ar, 'backward' )
+          CALL fft_y( ar, 'backward' )
           CALL cpu_log( log_point_s(7), 'fft_y', 'stop' )
 
@@ -280,5 +282,5 @@
 
           CALL cpu_log( log_point_s(4), 'fft_x', 'continue' )
-          CALL fftxp( ar, 'backward' )
+          CALL fft_x( ar, 'backward' )
           CALL cpu_log( log_point_s(4), 'fft_x', 'stop' )
 
@@ -295,25 +297,56 @@
 !
 !--    Two-dimensional Fourier Transformation along x- and y-direction.
+       CALL cpu_log( log_point_s(5), 'transpo forward', 'start' )
+       !$acc data copyin( ar, work )
+       CALL transpose_zx( ar, work, ar )
+       !$acc update host( ar )
+       CALL cpu_log( log_point_s(5), 'transpo forward', 'pause' )
+       
+
        CALL cpu_log( log_point_s(4), 'fft_x', 'start' )
-       CALL fftx( ar, 'forward' )
+       CALL fft_x( ar, 'forward' )
        CALL cpu_log( log_point_s(4), 'fft_x', 'pause' )
+
+       CALL cpu_log( log_point_s(5), 'transpo forward', 'continue' )
+       CALL transpose_xy( ar, work, ar )
+       CALL cpu_log( log_point_s(5), 'transpo forward', 'pause' )
+
        CALL cpu_log( log_point_s(7), 'fft_y', 'start' )
-       CALL ffty( ar, 'forward' )
+       CALL fft_y( ar, 'forward' )
        CALL cpu_log( log_point_s(7), 'fft_y', 'pause' )
 
 !
-!--    Solve the Poisson equation in z-direction in cartesian space.
+!--    Solve the tridiagonal equation system along z
+       CALL cpu_log( log_point_s(5), 'transpo forward', 'continue' )
+       CALL transpose_yz( ar, work, ar )
+       CALL cpu_log( log_point_s(5), 'transpo forward', 'stop' )
+
        CALL cpu_log( log_point_s(6), 'tridia', 'start' )
        CALL tridia( ar )
        CALL cpu_log( log_point_s(6), 'tridia', 'stop' )
 
+       CALL cpu_log( log_point_s(8), 'transpo invers', 'start' )
+       CALL transpose_zy( ar, work, ar )
+       CALL cpu_log( log_point_s(8), 'transpo invers', 'pause' )
+
 !
 !--    Inverse Fourier Transformation.
        CALL cpu_log( log_point_s(7), 'fft_y', 'continue' )
-       CALL ffty( ar, 'backward' )
+       CALL fft_y( ar, 'backward' )
        CALL cpu_log( log_point_s(7), 'fft_y', 'stop' )
+
+       CALL cpu_log( log_point_s(8), 'transpo invers', 'continue' )
+       CALL transpose_yx( ar, work, ar )
+       CALL cpu_log( log_point_s(8), 'transpo invers', 'pause' )
+
        CALL cpu_log( log_point_s(4), 'fft_x', 'continue' )
-       CALL fftx( ar, 'backward' )
+       CALL fft_x( ar, 'backward' )
        CALL cpu_log( log_point_s(4), 'fft_x', 'stop' )
+
+       CALL cpu_log( log_point_s(8), 'transpo invers', 'continue' )
+       CALL transpose_xz( ar, work, ar )
+       CALL cpu_log( log_point_s(8), 'transpo invers', 'stop' )
+
+       !$acc end data
 
 #endif
@@ -346,9 +379,5 @@
        REAL, DIMENSION(5,nxl_z:nxr_z,0:nz-1) ::  tri
 
-#if defined( __parallel )
        REAL    ::  ar(nxl_z:nxr_z,nys_z:nyn_z,1:nz)
-#else
-       REAL    ::  ar(1:nz,nys_z:nyn_z,nxl_z:nxr_z)
-#endif
 
 
@@ -494,17 +523,9 @@
 !--       Forward substitution.
           DO  i = nxl_z, nxr_z
-#if defined( __parallel )
              ar1(i,0) = ar(i,j,1)
-#else
-             ar1(i,0) = ar(1,j,i)
-#endif
           ENDDO
           DO  k = 1, nz - 1
              DO  i = nxl_z, nxr_z
-#if defined( __parallel )
                 ar1(i,k) = ar(i,j,k+1) - tri(5,i,k) * ar1(i,k-1)
-#else
-                ar1(i,k) = ar(k+1,j,i) - tri(5,i,k) * ar1(i,k-1)
-#endif
              ENDDO
           ENDDO
@@ -516,19 +537,10 @@
 !--       the model domain.
           DO  i = nxl_z, nxr_z
-#if defined( __parallel )
              ar(i,j,nz) = ar1(i,nz-1) / ( tri(4,i,nz-1) + 1.0E-20 )
-#else
-             ar(nz,j,i) = ar1(i,nz-1) / ( tri(4,i,nz-1) + 1.0E-20 )
-#endif
           ENDDO
           DO  k = nz-2, 0, -1
              DO  i = nxl_z, nxr_z
-#if defined( __parallel )
                 ar(i,j,k+1) = ( ar1(i,k) - tri(3,i,k) * ar(i,j,k+2) ) &
                               / tri(4,i,k)
-#else
-                ar(k+1,j,i) = ( ar1(i,k) - tri(3,i,k) * ar(k+2,j,i) ) &
-                              / tri(4,i,k)
-#endif
              ENDDO
           ENDDO
@@ -540,13 +552,7 @@
           IF ( ibc_p_b == 1  .AND.  ibc_p_t == 1 )  THEN
              IF ( j == 0  .AND.  nxl_z == 0 )  THEN
-#if defined( __parallel )
                 DO  k = 1, nz
                    ar(nxl_z,j,k) = 0.0
                 ENDDO
-#else
-                DO  k = 1, nz
-                   ar(k,j,nxl_z) = 0.0
-                ENDDO
-#endif
              ENDIF
           ENDIF
@@ -581,111 +587,4 @@
     END SUBROUTINE tridia
 
-
-#if defined( __parallel )
-    SUBROUTINE fftxp( ar, direction )
-
-!------------------------------------------------------------------------------!
-! Fourier-transformation along x-direction                 Parallelized version
-!------------------------------------------------------------------------------!
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=*) ::  direction
-       INTEGER           ::  j, k
-       REAL              ::  ar(0:nx,nys_x:nyn_x,nzb_x:nzt_x)
-
-!
-!--    Performing the fft with one of the methods implemented
-!$OMP  PARALLEL PRIVATE ( j, k )
-!$OMP  DO
-       DO  k = nzb_x, nzt_x
-          DO  j = nys_x, nyn_x
-             CALL fft_x( ar(0:nx,j,k), direction )
-          ENDDO
-       ENDDO
-!$OMP  END PARALLEL
-
-    END SUBROUTINE fftxp
-
-#else
-    SUBROUTINE fftx( ar, direction )
-
-!------------------------------------------------------------------------------!
-! Fourier-transformation along x-direction                 Non parallel version
-!------------------------------------------------------------------------------!
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=*) ::  direction
-       INTEGER           ::  i, j, k
-       REAL              ::  ar(1:nz,0:ny,0:nx)
-
-!
-!--    Performing the fft with one of the methods implemented
-!$OMP  PARALLEL PRIVATE ( j, k )
-!$OMP  DO
-       DO  k = 1, nz
-          DO  j = 0, ny
-             CALL fft_x( ar(k,j,0:nx), direction )
-          ENDDO
-       ENDDO
-!$OMP  END PARALLEL
-
-    END SUBROUTINE fftx
-#endif
-
-
-#if defined( __parallel )
-    SUBROUTINE fftyp( ar, direction )
-
-!------------------------------------------------------------------------------!
-! Fourier-transformation along y-direction                 Parallelized version
-!------------------------------------------------------------------------------!
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=*) ::  direction
-       INTEGER           ::  i, k
-       REAL              ::  ar(0:ny,nxl_y:nxr_y,nzb_y:nzt_y)
-
-!
-!--    Performing the fft with one of the methods implemented
-!$OMP  PARALLEL PRIVATE ( i, k )
-!$OMP  DO
-       DO  k = nzb_y, nzt_y
-          DO  i = nxl_y, nxr_y
-             CALL fft_y( ar(0:ny,i,k), direction )
-          ENDDO
-       ENDDO
-!$OMP  END PARALLEL
-
-    END SUBROUTINE fftyp
-
-#else
-    SUBROUTINE ffty( ar, direction )
-
-!------------------------------------------------------------------------------!
-! Fourier-transformation along y-direction                 Non parallel version
-!------------------------------------------------------------------------------!
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=*) ::  direction
-       INTEGER           ::  i, k
-       REAL              ::  ar(1:nz,0:ny,0:nx)
-
-!
-!--    Performing the fft with one of the methods implemented
-!$OMP  PARALLEL PRIVATE ( i, k )
-!$OMP  DO
-       DO  k = 1, nz
-          DO  i = 0, nx
-             CALL fft_y( ar(k,0:ny,i), direction )
-          ENDDO
-       ENDDO
-!$OMP  END PARALLEL
-
-    END SUBROUTINE ffty
-#endif
 
 #if defined( __parallel )
@@ -729,5 +628,5 @@
 !--    1d-decomposition along x. Resort the data in a way that x becomes
 !--    the first index.
-       CALL cpu_log( log_point_s(7), 'fft_y', 'start' )
+       CALL cpu_log( log_point_s(7), 'fft_y_1d', 'start' )
 
        IF ( host(1:3) == 'nec' )  THEN
@@ -782,5 +681,5 @@
 !
 !--                FFT along y
-                   CALL fft_y( work_ffty(:,ir), 'forward' )
+                   CALL fft_y_1d( work_ffty(:,ir), 'forward' )
 
                 ENDDO
@@ -800,5 +699,5 @@
 
        ENDIF
-       CALL cpu_log( log_point_s(7), 'fft_y', 'pause' )
+       CALL cpu_log( log_point_s(7), 'fft_y_1d', 'pause' )
 
 !
@@ -853,5 +752,5 @@
 !--    Resort the data in a way that y becomes the first index and carry out the
 !--    backward fft along y.
-       CALL cpu_log( log_point_s(7), 'fft_y', 'continue' )
+       CALL cpu_log( log_point_s(7), 'fft_y_1d', 'continue' )
 
        IF ( host(1:3) == 'nec' )  THEN
@@ -910,5 +809,5 @@
 !--                FFT along y
                    ir = i-iouter+1  ! counter within a stride
-                   CALL fft_y( work_ffty(:,ir), 'backward' )
+                   CALL fft_y_1d( work_ffty(:,ir), 'backward' )
 
                    DO  j = 0, ny
@@ -924,5 +823,5 @@
        ENDIF
 
-       CALL cpu_log( log_point_s(7), 'fft_y', 'stop' )
+       CALL cpu_log( log_point_s(7), 'fft_y_1d', 'stop' )
 
     END SUBROUTINE tr_xy_ffty
@@ -958,5 +857,5 @@
 
 
-       CALL cpu_log( log_point_s(33), 'fft_x + tridia', 'start' )
+       CALL cpu_log( log_point_s(33), 'fft_x_1d + tridia', 'start' )
 
        ALLOCATE( tri(5,0:nx,0:nz-1,0:threads_per_task-1) )
@@ -998,5 +897,5 @@
                 ENDDO
 
-                CALL fft_x( work_fftx, 'forward' )
+                CALL fft_x_1d( work_fftx, 'forward' )
 
                 DO  i = 0, nx
@@ -1038,5 +937,5 @@
                 ENDDO
 
-                CALL fft_x( work_fftx, 'backward' )
+                CALL fft_x_1d( work_fftx, 'backward' )
 
                 m = 0
@@ -1056,5 +955,5 @@
        DEALLOCATE( tri )
 
-       CALL cpu_log( log_point_s(33), 'fft_x + tridia', 'stop' )
+       CALL cpu_log( log_point_s(33), 'fft_x_1d + tridia', 'stop' )
 
     END SUBROUTINE fftx_tri_fftx
@@ -1092,5 +991,5 @@
 !--    1d-decomposition along y. Resort the data in a way that y becomes
 !--    the first index.
-       CALL cpu_log( log_point_s(4), 'fft_x', 'start' )
+       CALL cpu_log( log_point_s(4), 'fft_x_1d', 'start' )
 
        IF ( host(1:3) == 'nec' )  THEN
@@ -1144,5 +1043,5 @@
              DO  k = 1, nz
 
-                CALL fft_x( work_fftx(0:nx,k,j), 'forward' )
+                CALL fft_x_1d( work_fftx(0:nx,k,j), 'forward' )
 
                 DO  i = 0, nx
@@ -1155,5 +1054,5 @@
 
        ENDIF
-       CALL cpu_log( log_point_s(4), 'fft_x', 'pause' )
+       CALL cpu_log( log_point_s(4), 'fft_x_1d', 'pause' )
 
 !
@@ -1205,5 +1104,5 @@
 !--    1d-decomposition along y. Resort the data in a way that y becomes
 !--    the first index.
-       CALL cpu_log( log_point_s(4), 'fft_x', 'continue' )
+       CALL cpu_log( log_point_s(4), 'fft_x_1d', 'continue' )
 
        IF ( host(1:3) == 'nec' )  THEN
@@ -1248,5 +1147,5 @@
                 ENDDO
 
-                CALL fft_x( work_fftx(0:nx,k,j), 'backward' )
+                CALL fft_x_1d( work_fftx(0:nx,k,j), 'backward' )
 
              ENDDO
@@ -1264,5 +1163,5 @@
 
        ENDIF
-       CALL cpu_log( log_point_s(4), 'fft_x', 'stop' )
+       CALL cpu_log( log_point_s(4), 'fft_x_1d', 'stop' )
 
     END SUBROUTINE tr_yx_fftx
@@ -1298,5 +1197,5 @@
 
 
-       CALL cpu_log( log_point_s(39), 'fft_y + tridia', 'start' )
+       CALL cpu_log( log_point_s(39), 'fft_y_1d + tridia', 'start' )
 
        ALLOCATE( tri(5,0:ny,0:nz-1,0:threads_per_task-1) )
@@ -1338,5 +1237,5 @@
                 ENDDO
 
-                CALL fft_y( work_ffty, 'forward' )
+                CALL fft_y_1d( work_ffty, 'forward' )
 
                 DO  j = 0, ny
@@ -1378,5 +1277,5 @@
                 ENDDO
 
-                CALL fft_y( work_ffty, 'backward' )
+                CALL fft_y_1d( work_ffty, 'backward' )
 
                 m = 0
@@ -1396,5 +1295,5 @@
        DEALLOCATE( tri )
 
-       CALL cpu_log( log_point_s(39), 'fft_y + tridia', 'stop' )
+       CALL cpu_log( log_point_s(39), 'fft_y_1d + tridia', 'stop' )
 
     END SUBROUTINE ffty_tri_ffty
